; -----------------------------------------------------------------------------
; Star Castle 2600 - Copyright (C) 2012 Chris Walton (cd-w) <cwalton@gmail.com>
; Bank 4 - Gun & Explosion Frames
; -----------------------------------------------------------------------------

  ; Bank 4
  SEG     BANK4
  ORG     $4000
  RORG    $F000
  
  ; Space for RAM+
  DS.B    512,35

Init4
  nop     $FFFB             ; Switch to Bank 6
  nop
  nop
  nop
  jmp     DrawGun
ExitRotate
  nop     $FFF5             ; Switch to Bank 0
  jmp     DrawExplosion
  
; -----------------------------------------------------------------------------
; Draw Gun Turret
; -----------------------------------------------------------------------------

DrawGun
  ; Draw Gun
  ldx GUNDIR                ; [0] + 3
  lda CYCLE                 ; [3] + 3
  and #%00011000            ; [6] + 2
  clc                       ; [8] + 2
  adc GunPtrLo,X            ; [10] + 4
  sta BPTR                  ; [14] + 3
  lda GunPtrHi,X            ; [17] + 2
  sta BPTR+1                ; [19] + 3
  ldy #7                    ; [22] + 2 = 24
DrawGunLoop
  lda (BPTR),Y              ; [0] + 5
  sta GRID_W+96,Y           ; [5] + 5
  dey                       ; [10] + 2
  bpl DrawGunLoop           ; [12] + 2/3
                            ; TOTAL = 15*8 = 120
  jmp ExitRotate

; -----------------------------------------------------------------------------
; Draw Explosion Frame
; -----------------------------------------------------------------------------

DrawExplosion
  ; Set Explosion Pointers (X = Frame)
  lda ExplodePtrLo+0,X      ; [3] + 4
  sta EXP0                  ; [7] + 3
  lda ExplodePtrHi+0,X      ; [10] + 4
  sta EXP0+1                ; [14] + 3
  lda ExplodePtrLo+1,X      ; [17] + 4
  sta EXP1                  ; [21] + 3
  lda ExplodePtrHi+1,X      ; [24] + 4
  sta EXP1+1                ; [28] + 3
  lda ExplodePtrLo+2,X      ; [31] + 4
  sta EXP2                  ; [35] + 3
  lda ExplodePtrHi+2,X      ; [38] + 4
  sta EXP2+1                ; [42] + 3
  lda ExplodePtrLo+3,X      ; [45] + 4
  sta EXP3                  ; [49] + 3
  lda ExplodePtrHi+3,X      ; [52] + 4
  sta EXP3+1                ; [56] + 3
  lda ExplodePtrLo+4,X      ; [59] + 4
  sta EXP4                  ; [63] + 3
  lda ExplodePtrHi+4,X      ; [66] + 4
  sta EXP4+1                ; [70] + 3

  ; Draw Frame
  ldy #39
DrawExplodeLoop
  lda (EXP0),Y              ; [0] + 5
  sta GRID_W+0,Y            ; [5] + 5
  lda (EXP1),Y              ; [10] + 5
  sta GRID_W+40,Y           ; [15] + 5
  lda (EXP2),Y              ; [20] + 5
  sta GRID_W+80,Y           ; [25] + 5
  lda (EXP3),Y              ; [30] + 5
  sta GRID_W+120,Y          ; [35] + 5
  lda (EXP4),Y              ; [40] + 5
  sta GRID_W+160,Y          ; [45] + 5
  dey                       ; [50] + 2
  bpl DrawExplodeLoop       ; [52] + 2/3
  jmp ExitRotate            ; TOTAL = 40*55 = 2200 (29 SCANLINES)

; -----------------------------------------------------------------------------
; Gun & Explosion Data
; -----------------------------------------------------------------------------

  ; Gun Pointers (Lo)
  ; 8*4 (32 bytes)
GunPtrLo
  DC.B  <Gun0, <Gun1, <Gun2, <Gun3, <Gun4, <Gun5, <Gun6, <Gun7
  DC.B  <Gun8, <Gun9, <Gun10, <Gun11, <Gun12, <Gun13, <Gun14, <Gun15
  DC.B  <Gun16, <Gun17, <Gun18, <Gun19, <Gun20, <Gun21, <Gun22, <Gun23
  DC.B  <Gun24, <Gun25, <Gun26, <Gun27, <Gun28, <Gun29, <Gun30, <Gun31
EndGunPtrLo
  if (>GunPtrLo != >EndGunPtrLo)
    echo "WARNING: GunPtrLo crosses a page boundary!"
  endif

  ; Explosion Pointers (Lo)
  ; 17*5 (85 bytes)
ExplodePtrLo
  DC.B  <Explode4_0, <Explode4_0, <Explode4_0, <Explode4_0, <Explode4_0 ; Blank
  DC.B  <Explode0_0, <Explode0_1, <Explode0_2, <Explode0_3, <Explode0_4
  DC.B  <Explode1_0, <Explode1_1, <Explode1_2, <Explode1_3, <Explode1_4
  DC.B  <Explode2_0, <Explode2_1, <Explode2_2, <Explode2_3, <Explode2_4
  DC.B  <Explode3_0, <Explode3_1, <Explode3_2, <Explode3_3, <Explode3_4
  DC.B  <Explode4_0, <Explode4_1, <Explode4_2, <Explode4_3, <Explode4_4
  DC.B  <Explode5_0, <Explode5_1, <Explode5_2, <Explode5_3, <Explode5_4
  DC.B  <Explode6_0, <Explode6_1, <Explode6_2, <Explode6_3, <Explode6_4
  DC.B  <Explode7_0, <Explode7_1, <Explode7_2, <Explode7_3, <Explode7_4
  DC.B  <Explode8_0, <Explode8_1, <Explode8_2, <Explode8_3, <Explode8_4
  DC.B  <Explode9_0, <Explode9_1, <Explode9_2, <Explode9_3, <Explode9_4
  DC.B  <Explode10_0, <Explode10_1, <Explode10_2, <Explode10_3, <Explode10_4
  DC.B  <Explode11_0, <Explode11_1, <Explode11_2, <Explode11_3, <Explode11_4
  DC.B  <Explode12_0, <Explode12_1, <Explode12_2, <Explode12_3, <Explode12_4
  DC.B  <Explode13_0, <Explode13_1, <Explode13_2, <Explode13_3, <Explode13_4
  DC.B  <Explode14_0, <Explode14_1, <Explode14_2, <Explode14_3, <Explode14_4
  DC.B  <Explode15_0, <Explode15_1, <Explode15_2, <Explode15_3, <Explode15_4
EndExplodePtrLo
  if (>ExplodePtrLo != >ExplodePtrLo)
    echo "WARNING: ExplodePtrLo crosses a page boundary!"
  endif

  DC.B  "STAR"

  ALIGN 256
  GUNDATA0

  ALIGN 256
  GUNDATA1

  ALIGN 256
  GUNDATA2

  ALIGN 256
  GUNDATA3

  ALIGN 256
  EXPLOSIONDATA0
  DC.B  "STAR0"

  ALIGN 256
  EXPLOSIONDATA1
  DC.B  "STAR1"
  
  ALIGN 256
  EXPLOSIONDATA2
  DC.B  "STAR2"

  ALIGN 256
  EXPLOSIONDATA3
  DC.B  "STAR3"

  ALIGN 256
  EXPLOSIONDATA4
  DC.B  "STAR4"

  ALIGN 256
  EXPLOSIONDATA5
  DC.B  "STAR5"

  ALIGN 256
  EXPLOSIONDATA6
  DC.B  "STAR6"

  ALIGN 256
  EXPLOSIONDATA7
  DC.B  "STAR7"

  ALIGN 256
  EXPLOSIONDATA8

  ; Gun Pointers (Hi)
GunPtrHi
  DC.B  >Gun0, >Gun1, >Gun2, >Gun3, >Gun4, >Gun5, >Gun6, >Gun7
  DC.B  >Gun8, >Gun9, >Gun10, >Gun11, >Gun12, >Gun13, >Gun14, >Gun15
  DC.B  >Gun16, >Gun17, >Gun18, >Gun19, >Gun20, >Gun21, >Gun22, >Gun23
  DC.B  >Gun24, >Gun25, >Gun26, >Gun27, >Gun28, >Gun29, >Gun30, >Gun31
EndGunPtrHi
  if (>GunPtrHi != >EndGunPtrHi)
    echo "WARNING: GunPtrHi crosses a page boundary!"
  endif

  ; Explosion Pointers (Hi)
ExplodePtrHi
  DC.B  >Explode4_0, >Explode4_0, >Explode4_0, >Explode4_0, >Explode4_0 ; Blank
  DC.B  >Explode0_0, >Explode0_1, >Explode0_2, >Explode0_3, >Explode0_4
  DC.B  >Explode1_0, >Explode1_1, >Explode1_2, >Explode1_3, >Explode1_4
  DC.B  >Explode2_0, >Explode2_1, >Explode2_2, >Explode2_3, >Explode2_4
  DC.B  >Explode3_0, >Explode3_1, >Explode3_2, >Explode3_3, >Explode3_4
  DC.B  >Explode4_0, >Explode4_1, >Explode4_2, >Explode4_3, >Explode4_4
  DC.B  >Explode5_0, >Explode5_1, >Explode5_2, >Explode5_3, >Explode5_4
  DC.B  >Explode6_0, >Explode6_1, >Explode6_2, >Explode6_3, >Explode6_4
  DC.B  >Explode7_0, >Explode7_1, >Explode7_2, >Explode7_3, >Explode7_4
  DC.B  >Explode8_0, >Explode8_1, >Explode8_2, >Explode8_3, >Explode8_4
  DC.B  >Explode9_0, >Explode9_1, >Explode9_2, >Explode9_3, >Explode9_4
  DC.B  >Explode10_0, >Explode10_1, >Explode10_2, >Explode10_3, >Explode10_4
  DC.B  >Explode11_0, >Explode11_1, >Explode11_2, >Explode11_3, >Explode11_4
  DC.B  >Explode12_0, >Explode12_1, >Explode12_2, >Explode12_3, >Explode12_4
  DC.B  >Explode13_0, >Explode13_1, >Explode13_2, >Explode13_3, >Explode13_4
  DC.B  >Explode14_0, >Explode14_1, >Explode14_2, >Explode14_3, >Explode14_4
  DC.B  >Explode15_0, >Explode15_1, >Explode15_2, >Explode15_3, >Explode15_4
EndExplodePtrHi
  if (>ExplodePtrHi != >ExplodePtrHi)
    echo "WARNING: ExplodePtrHi crosses a page boundary!"
  endif

  DC.B  "STAR8"

  echo "----",($FFF4 - *) , "bytes left (BANK4 - GUN & EXPLOSIONS)"

  ORG     $4FF4
  RORG    $FFF4
  DC.B    "BANK4", 0, 0, 0
  DC.W    Init4, Init4
  
